# Introduction

> If you are not familiar with Dioxus itself, check out the [Dioxus book](https://dioxuslabs.com/docs/0.3/guide/en/) first.

Whether you are building a website, desktop app, or mobile app,
splitting your app's views into "pages" can be an effective method for
organization and maintainability.

For this purpose, Dioxus provides a router. Use the `cargo add` command to add the dependency:

```sh
cargo add dioxus-router
```

This book is intended to get you up to speed with Dioxus Router. It is split
into two sections:

1. The [reference](./reference/index.md) section explains individual features in
   depth. You can read it from start to finish, or you can read individual chapters
   in whatever order you want.
2. If you prefer a learning-by-doing approach, you can check out the
   _[example project](./example/index.md)_. It guides you through
   creating a dioxus app, setting up the router, and using some of its
   functionality.

> Please note that this is not the only documentation for the Dioxus Router. You
> can also check out the [API Docs](https://docs.rs/dioxus-router/).
